const bpPrefs = Components.classes["@mozilla.org/preferences-service;1"]
	.getService(Components.interfaces.nsIPrefService)
	.QueryInterface(Components.interfaces.nsIPrefBranch);
const bp_Branch = bpPrefs.getBranch("bp.");

function bpquikmapsinit(){
$$('sidebar-box').width = "420";
plusQuikmapsOpen();
}

function plusQuikmapsKeyHandler(event)
{
    if(event.keyCode == event.DOM_VK_RETURN)
        {setQuikmapsId(); plusOpenQuikmaps();}
}

function plusQuikmapsOpen() {
var source = "http://www.quikmaps.com/ext/15886?w=350&mh=250&t=1&ln=0&sn=1&zb=0&zs=0&d=1&it=0&icd=0&lat=37.38611&lng=-122.08278&zl=11&mt=0";
$('blog-plus-quikmap-iframe').setAttribute('src',source);
} 



function plusGeocode() {
var bpstrbundle = document.getElementById("bpstrings");
var addressprompt = bpstrbundle.getString("addressPrompt");
var address = prompt(addressprompt, "");
gAddress = address;
  encodedAddress = encodeURI(address);
  XXX('address pre-encoding:',  address );
  XXX('Encoded address ', encodedAddress);
  XXX('Address ', typeof(gAddress) );
  
 req = new XMLHttpRequest ();   
    req.onreadystatechange = getPlusQuikmapsMapsResponse; 
    req.open("GET","http://maps.google.com/maps/geo?q="+encodedAddress+"&output=xml&key=ABQIAAAAYgWXR5db6m93gnVrMsuXtxQncSHX4Q3-Ab3FozCaoQoCHwys1RTHg7pQTMlWwiL_zaU6tQ386P4zMw",true);
    req.send(null);

}

function getPlusQuikmapsMapsResponse(){
  if (req.readyState == 4) { 
    if (req.status == 200) 
    { 
    var resultset = req.responseXML.getElementsByTagName("Response")[0];   
    var placemark = resultset.getElementsByTagName("Placemark")[0];
    var result = placemark.getElementsByTagName("Point")[0];
    var thecoord = result.getElementsByTagName("coordinates")[0].textContent;
    var lat = thecoord.split(",")[1];
    var lng = thecoord.split(",")[0];
  $('plus-quikmaps-lat').setAttribute('value',lat);
  $('plus-quikmaps-lng').setAttribute('value',lng);
plusQuikmapsRefresh();  
} 
  } 
} 

function plusQuikmapsRefresh(){
var id = $('plus-quikmaps-id').value;
if (id == "") {
var qid = "15886";
}
if (id != "") {
var qid = id;
}
var lat = $('plus-quikmaps-lat').value;
var lng = $('plus-quikmaps-lng').value;
var mt = $('plus-quikmaps-maptype').value;
var tc = $('plus-quikmaps-maptype-controls').checked;
if (tc == true) {
var t = "1";
}
if (tc == false) {
var t = "0";
}
var zt = $('plus-quikmaps-zoomtype').value;
if (zt == "0") {
var zott = "&ln=0&sn=0&zb=0";
}
if (zt == "1") {
var zot = "&ln=0&sn=0&zb=1";
}
if (zt == "2") {
var zot = "&ln=0&sn=1&zb=0";
}
if (zt == "3") {
var zot = "&ln=1&sn=0&zb=0";
}
var z = $('plus-quikmaps-zoom').value;
var dr = $('plus-quikmaps-draggable').checked;
if (dr == true) {
var d = "1";
}
if (dr == false) {
var d = "0";
}
var sc = $('plus-quikmaps-scale').checked;
if (sc == true) {
var zs = "1";
}
if (sc == false) {
var zs = "0";
}
var ti = $('plus-quikmaps-title').checked;
if (ti == true) {
var it = "1";
}
if (ti == false) {
var it = "0";
}
var de = $('plus-quikmaps-description').checked;
if (de == true) {
var icd = "1";
}
if (de == false) {
var ict = "0";
}
var w = $('plus-quikmaps-width').value;
var h = $('plus-quikmaps-height').value;

var quikmapsurl = "http://www.quikmaps.com/ext/" + qid + "?w=" + w + "&mh=" + h + "&t=" + t + zot + "&zs=" + zs + "&d=" + d + "&it=" + it + "&icd=" + icd + "&lat=" + lat + "&lng=" + lng + "&zl=" + z + "&mt=" + mt;
$('blog-plus-quikmap-iframe').setAttribute('src',quikmapsurl);
}

function plusQuikmapsLatLngInsert(){
var lat = bpPrefs.getCharPref("extensions.blogplus.lat");
var lng = bpPrefs.getCharPref("extensions.blogplus.lng");
$('plus-quikmaps-lat').setAttribute('value',lat);
$('plus-quikmaps-lng').setAttribute('value',lng);
plusQuikmapsRefresh();
}

function plusOpenQuikmaps() {
window.openDialog("chrome://blogplus/content/quikmapsDialog.xul", "quikmapsDialog", "modal, centerscreen");
}

function setQuikmapsId() {
var qid = $('plus-quikmaps-id').value;
bpPrefs.setCharPref("extensions.blogplus.quikmapsid",qid);
}

function plusQuikmapsSrc() {
var qid = bpPrefs.getCharPref("extensions.blogplus.quikmapsid");
var source = "http://quikmaps.com/site/"+qid;
document.getElementById('blogplus-quikmaps-minibrowser').setAttribute('src',source);
quikmapsTimeout();
}

function quikmapsTimeout(){
setTimeout("plusGetQuikmapsId()",3000)
}

function plusGetQuikmapsId() {
var cdoc = document.getElementById("blogplus-quikmaps-minibrowser").contentDocument
    .getElementById("code").value;
var lat = cdoc.split("lat=")[1];
var latb = lat.split("&lng")[0];
var lng = lat.split("&lng=")[1];
var lngb = lng.split("&zl")[0];
bpPrefs.setCharPref("extensions.blogplus.lat",latb);
bpPrefs.setCharPref("extensions.blogplus.lng",lngb);
opener.plusQuikmapsLatLngInsert(); 
closeWindow('quikmapsMapsDialog');
}

function plusQuikmapsInsert() {
var id = $('plus-quikmaps-id').value;
if (id == "") {
var qid = "15886";
}
if (id != "") {
var qid = id;
}
var lat = $('plus-quikmaps-lat').value;
var lng = $('plus-quikmaps-lng').value;
var mt = $('plus-quikmaps-maptype').value;
var tc = $('plus-quikmaps-maptype-controls').checked;
if (tc == true) {
var t = "1";
}
if (tc == false) {
var t = "0";
}
var zt = $('plus-quikmaps-zoomtype').value;
if (zt == "0") {
var zot = "&ln=0&sn=0&zb=0";
}
if (zt == "1") {
var zot = "&ln=0&sn=0&zb=1";
}
if (zt == "2") {
var zot = "&ln=0&sn=1&zb=0";
}
if (zt == "3") {
var zot = "&ln=1&sn=0&zb=0";
}
var z = $('plus-quikmaps-zoom').value;
var dr = $('plus-quikmaps-draggable').checked;
if (dr == true) {
var d = "1";
}
if (dr == false) {
var d = "0";
}
var sc = $('plus-quikmaps-scale').checked;
if (sc == true) {
var zs = "1";
}
if (sc == false) {
var zs = "0";
}
var ti = $('plus-quikmaps-title').checked;
if (ti == true) {
var it = "1";
}
if (ti == false) {
var it = "0";
}
var de = $('plus-quikmaps-description').checked;
if (de == true) {
var icd = "1";
}
if (de == false) {
var ict = "0";
}
var w = $('plus-quikmaps-width').value;
var h = $('plus-quikmaps-height').value;
var wb = parseInt(w)+2;
var hb = parseInt(h)+28;
var quikmapsurl = "<iframe width='"+wb + "' height='" + hb + "' frameborder='0' scrolling='no' marginwidth='0' marginheight='0' src='http://www.quikmaps.com/ext/" + qid + "?w=" + w + "&mh=" + h + "&t=" + t + zot + "&zs=" + zs + "&d=" + d + "&it=" + it + "&icd=" + icd + "&lat=" + lat + "&lng=" + lng + "&zl=" + z + "&mt=" + mt +"'/>";

bp$$edit().contentWindow.document.execCommand("inserthtml", false, quikmapsurl);
}