const gPrefs = Components.classes["@mozilla.org/preferences-service;1"]
	.getService(Components.interfaces.nsIPrefService)
	.QueryInterface(Components.interfaces.nsIPrefBranch);
const gmaps_Branch = gPrefs.getBranch("gmaps.");

function openGeotag() {
 var tabbox = $("batch-single").selectedIndex;
 try{
 var flickAcc = $("servicesMenuList").value;
 flickAcc = flickAcc.split('urn:flock:flickr:account:')[1];
 gPrefs.setCharPref("extensions.gmaps.flickr.user", flickAcc);  
 }
 catch(err){} 
if (tabbox == "1"){
  gPrefs.setCharPref("extensions.gmaps.picture.tags", $("tags").value);  
}
 if (tabbox == "0"){
  gPrefs.setCharPref("extensions.gmaps.picture.tags", $("batch_tags").value);  
}
  window.openDialog("chrome://minimap/content/geotagDialog.xul", "topbarMapsDialog", "modal, centerscreen");
}


function prefsGeotag() {
 var tabbox = $("batch-single").selectedIndex;
 if (tabbox == "1"){
  var thetags = $("tags");
  var tags = thetags.value;
  var thedesc = $('description');
  var descr = thedesc.value;
 }
if (tabbox == "0"){
  var thetags = $("batch_tags");
  var tags = thetags.value;
  var thedesc = $('batch-description');
  var descr = thedesc.value;
}
  // Ghismo 20061227 : Now allows to geotag a picture that has already been geotagged
	var geotagLat = gPrefs.getCharPref("extensions.gmaps.geotagLat");
	var geotagLon = gPrefs.getCharPref("extensions.gmaps.geotagLon");

  // If the user asked to, adds a link to google maps in the description
  if (gPrefs.getBoolPref("extensions.gmaps.google.link")==true) {
    

    // If there is already a geotaggedwithflock link (one or many) in the description, then erase it (them), then trim the leading whitespace
    descr = descr.replace(new RegExp("<a class='geotaggedwithflock'[^>]*>[^<]+</a>", "gi"), "");
    descr = descr.replace(new RegExp("[ \t\r\n]+$", "gi"), "");
    // add the new link
    thedesc.value = descr + "\n<a class='geotaggedwithflock' href='http://maps.google.com/maps?q= " + geotagLat + "," + geotagLon +"(Geotagged Flickr Photo)&t=h'>See where this picture was taken.</a>";
  }

  // Then add the tags used for geotagging
  var sep = "";

  if (tags.match(new RegExp("geotagged", "gi")) || tags.match(new RegExp("geo:lat=", "gi")) || tags.match(new RegExp("geo:lon=", "gi"))) {
    // If the picture has already been tagged, then I reconstruct the tag string with preserving the tag order
    var atags = tags.split(",");
    var geoOk = false;
    var latOk = false;
    var lonOk = false;
    tags = "";
    for (var i=0;i<atags.length; i++) {
      if (atags[i]=="geotagged") {
        tags += sep + "geotagged";
        geoOk = true;
      } else if (atags[i].match(new RegExp("geo:lat=", "gi"))) {
        tags += sep + "geo:lat=" + new String(geotagLat);
        latOk = true;
      } else if (atags[i].match(new RegExp("geo:lon=", "gi"))) {
        tags += sep + "geo:lon=" + new String(geotagLon);
        lonOk = true;
      } else if (atags[i]=="geotaggedwithflock") {
        // do nothing, it will be added after
      } else {
        tags += sep + atags[i];
      }
      sep = ",";
    }
    // I have to look here if the needed tags are there, else have to add them 
    if (geoOk==false) tags += sep + "geotagged";
    if (latOk==false) tags += sep + "geo:lat=" + new String(geotagLat);
    if (lonOk==false) tags += sep + "geo:lon=" + new String(geotagLon);
  } else {
    // This picture wasn't geotagged : I add the needed keywords
    if (tags!="") sep=",";
    tags += sep + "geotagged,geo:lat=" + geotagLat + ",geo:lon=" + geotagLon;
  }
  thetags.value = tags
  if (gPrefs.getBoolPref("extensions.gmaps.geotagged")==true) thetags.value += ",geotaggedwithflock";
  /// Ghismo 20061227

}
